<?php 


class ControllerLocalisationZone extends Controller {


	private $error = array(); 





	public function index() {


		$this->load->language('localisation/zone');





		$this->document->setTitle($this->language->get('heading_title'));


		


		$this->load->model('localisation/zone');


		


		$this->getList();


	}





	public function insert() {


		$this->load->language('localisation/zone');





		$this->document->setTitle($this->language->get('heading_title'));


		


		$this->load->model('localisation/zone');


		


		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {


			$this->model_localisation_zone->addZone($this->request->post);


	


			$this->session->data['success'] = $this->language->get('text_success');


			


			$url = '';


			


			if (isset($this->request->get['sort'])) {


				$url .= '&sort=' . $this->request->get['sort'];


			}





			if (isset($this->request->get['order'])) {


				$url .= '&order=' . $this->request->get['order'];


			}





			if (isset($this->request->get['page'])) {


				$url .= '&page=' . $this->request->get['page'];


			}


			


			$this->redirect($this->url->link('localisation/zone', 'token=' . $this->session->data['token'] . $url, 'SSL'));


		}





		$this->getForm();


	}





	public function update() {


		$this->load->language('localisation/zone');





		$this->document->setTitle($this->language->get('heading_title'));


		


		$this->load->model('localisation/zone');


		


		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {


			$this->model_localisation_zone->editZone($this->request->get['zone_id'], $this->request->post);			


			


			$this->session->data['success'] = $this->language->get('text_success');


			


			$url = '';


			


			if (isset($this->request->get['sort'])) {


				$url .= '&sort=' . $this->request->get['sort'];


			}





			if (isset($this->request->get['order'])) {


				$url .= '&order=' . $this->request->get['order'];


			}





			if (isset($this->request->get['page'])) {


				$url .= '&page=' . $this->request->get['page'];


			}


			


			$this->redirect($this->url->link('localisation/zone', 'token=' . $this->session->data['token'] . $url, 'SSL'));


		}





		$this->getForm();


	}





	public function delete() {


		$this->load->language('localisation/zone');





		$this->document->setTitle($this->language->get('heading_title'));


		


		$this->load->model('localisation/zone');


		


		if (isset($this->request->post['selected']) && $this->validateDelete()) {


			foreach ($this->request->post['selected'] as $zone_id) {


				$this->model_localisation_zone->deleteZone($zone_id);


			}			


			


			$this->session->data['success'] = $this->language->get('text_success');


			


			$url = '';


			


			if (isset($this->request->get['sort'])) {


				$url .= '&sort=' . $this->request->get['sort'];


			}





			if (isset($this->request->get['order'])) {


				$url .= '&order=' . $this->request->get['order'];


			}





			if (isset($this->request->get['page'])) {


				$url .= '&page=' . $this->request->get['page'];


			}





			$this->redirect($this->url->link('localisation/zone', 'token=' . $this->session->data['token'] . $url, 'SSL'));


		}





		$this->getList();


	}





	private function getList() {


		if (isset($this->request->get['sort'])) {


			$sort = $this->request->get['sort'];


		} else {


			$sort = 'c.name';


		}


		


		if (isset($this->request->get['order'])) {


			$order = $this->request->get['order'];


		} else {


			$order = 'ASC';


		}


		


		if (isset($this->request->get['page'])) {


			$page = $this->request->get['page'];


		} else {


			$page = 1;


		}


				


		$url = '';


			


		if (isset($this->request->get['sort'])) {


			$url .= '&sort=' . $this->request->get['sort'];


		}





		if (isset($this->request->get['order'])) {


			$url .= '&order=' . $this->request->get['order'];


		}


		


		if (isset($this->request->get['page'])) {


			$url .= '&page=' . $this->request->get['page'];


		}





  		$this->data['breadcrumbs'] = array();





   		$this->data['breadcrumbs'][] = array(


       		'text'      => $this->language->get('text_home'),


			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),


      		'separator' => false


   		);





   		$this->data['breadcrumbs'][] = array(


       		'text'      => $this->language->get('heading_title'),


			'href'      => $this->url->link('localisation/zone', 'token=' . $this->session->data['token'] . $url, 'SSL'),


      		'separator' => ' :: '


   		);


							


		$this->data['insert'] = $this->url->link('localisation/zone/insert', 'token=' . $this->session->data['token'] . $url, 'SSL');


		$this->data['delete'] = $this->url->link('localisation/zone/delete', 'token=' . $this->session->data['token'] . $url, 'SSL');


	


		$this->data['zones'] = array();





		$data = array(


			'sort'  => $sort,


			'order' => $order,


			'start' => ($page - 1) * $this->config->get('config_admin_limit'),


			'limit' => $this->config->get('config_admin_limit')


		);


		


		$zone_total = $this->model_localisation_zone->getTotalZones();


			


		$results = $this->model_localisation_zone->getZones($data);





		foreach ($results as $result) {


			$action = array();


			


			$action[] = array(


				'text' => $this->language->get('text_edit'),


				'href' => $this->url->link('localisation/zone/update', 'token=' . $this->session->data['token'] . '&zone_id=' . $result['zone_id'] . $url, 'SSL')


			);


					


			$this->data['zones'][] = array(


				'zone_id'  => $result['zone_id'],


				'country'  => $result['country'],


				'name'     => $result['name'] . (($result['zone_id'] == $this->config->get('config_zone_id')) ? $this->language->get('text_default') : null),


				'code'     => $result['code'],


				'selected' => isset($this->request->post['selected']) && in_array($result['zone_id'], $this->request->post['selected']),


				'action'   => $action			


			);


		}


	


		$this->data['heading_title'] = $this->language->get('heading_title');





		$this->data['text_no_results'] = $this->language->get('text_no_results');





		$this->data['column_country'] = $this->language->get('column_country');


		$this->data['column_name'] = $this->language->get('column_name');


		$this->data['column_code'] = $this->language->get('column_code');


		$this->data['column_action'] = $this->language->get('column_action');	





		$this->data['button_insert'] = $this->language->get('button_insert');


		$this->data['button_delete'] = $this->language->get('button_delete');


 


 		if (isset($this->error['warning'])) {


			$this->data['error_warning'] = $this->error['warning'];


		} else {


			$this->data['error_warning'] = '';


		}





		if (isset($this->session->data['success'])) {


			$this->data['success'] = $this->session->data['success'];


		


			unset($this->session->data['success']);


		} else {


			$this->data['success'] = '';


		}


 


		$url = '';





		if ($order == 'ASC') {


			$url .= '&order=DESC';


		} else {


			$url .= '&order=ASC';


		}





		if (isset($this->request->get['page'])) {


			$url .= '&page=' . $this->request->get['page'];


		}


		 


		$this->data['sort_country'] = $this->url->link('localisation/zone', 'token=' . $this->session->data['token'] . '&sort=c.name' . $url, 'SSL');


		$this->data['sort_name'] = $this->url->link('localisation/zone', 'token=' . $this->session->data['token'] . '&sort=z.name' . $url, 'SSL');


		$this->data['sort_code'] = $this->url->link('localisation/zone', 'token=' . $this->session->data['token'] . '&sort=z.code' . $url, 'SSL');


		


		$url = '';





		if (isset($this->request->get['sort'])) {


			$url .= '&sort=' . $this->request->get['sort'];


		}


												


		if (isset($this->request->get['order'])) {


			$url .= '&order=' . $this->request->get['order'];


		}





		$pagination = new Pagination();


		$pagination->total = $zone_total;


		$pagination->page = $page;


		$pagination->limit = $this->config->get('config_admin_limit');


		$pagination->text = $this->language->get('text_pagination');


		$pagination->url = $this->url->link('localisation/zone', 'token=' . $this->session->data['token'] . $url . '&page={page}', 'SSL');





		$this->data['pagination'] = $pagination->render();


		


		$this->data['sort'] = $sort;


		$this->data['order'] = $order;





		$this->template = 'localisation/zone_list.tpl';


		$this->children = array(


			'common/header',


			'common/footer'


		);


				


		$this->response->setOutput($this->render());


	}





	private function getForm() {


		$this->data['heading_title'] = $this->language->get('heading_title');





		$this->data['entry_status'] = $this->language->get('entry_status');


		$this->data['entry_name'] = $this->language->get('entry_name');


		$this->data['entry_code'] = $this->language->get('entry_code');


		$this->data['entry_country'] = $this->language->get('entry_country');





		$this->data['text_enabled'] = $this->language->get('text_enabled');


		$this->data['text_disabled'] = $this->language->get('text_disabled');


		


		$this->data['button_save'] = $this->language->get('button_save');


		$this->data['button_cancel'] = $this->language->get('button_cancel');





 		if (isset($this->error['warning'])) {


			$this->data['error_warning'] = $this->error['warning'];


		} else {


			$this->data['error_warning'] = '';


		}


		


 		if (isset($this->error['name'])) {


			$this->data['error_name'] = $this->error['name'];


		} else {


			$this->data['error_name'] = '';


		}


		


		$url = '';


			


		if (isset($this->request->get['sort'])) {


			$url .= '&sort=' . $this->request->get['sort'];


		}





		if (isset($this->request->get['order'])) {


			$url .= '&order=' . $this->request->get['order'];


		}


		


		if (isset($this->request->get['page'])) {


			$url .= '&page=' . $this->request->get['page'];


		}





  		$this->data['breadcrumbs'] = array();





   		$this->data['breadcrumbs'][] = array(


       		'text'      => $this->language->get('text_home'),


			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),  		


      		'separator' => false


   		);





   		$this->data['breadcrumbs'][] = array(


       		'text'      => $this->language->get('heading_title'),


			'href'      => $this->url->link('localisation/zone', 'token=' . $this->session->data['token'] . $url, 'SSL'),


      		'separator' => ' :: '


   		);


							


		if (!isset($this->request->get['zone_id'])) {


			$this->data['action'] = $this->url->link('localisation/zone/insert', 'token=' . $this->session->data['token'] . $url, 'SSL');


		} else {


			$this->data['action'] = $this->url->link('localisation/zone/update', 'token=' . $this->session->data['token'] . '&zone_id=' . $this->request->get['zone_id'] . $url, 'SSL');


		}


		 


		$this->data['cancel'] = $this->url->link('localisation/zone', 'token=' . $this->session->data['token'] . $url, 'SSL');





		if (isset($this->request->get['zone_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {


			$zone_info = $this->model_localisation_zone->getZone($this->request->get['zone_id']);


		}





		if (isset($this->request->post['status'])) {


			$this->data['status'] = $this->request->post['status'];


		} elseif (isset($zone_info)) {


			$this->data['status'] = $zone_info['status'];


		} else {


			$this->data['status'] = '1';


		}


		


		if (isset($this->request->post['name'])) {


			$this->data['name'] = $this->request->post['name'];


		} elseif (isset($zone_info)) {


			$this->data['name'] = $zone_info['name'];


		} else {


			$this->data['name'] = '';


		}





		if (isset($this->request->post['code'])) {


			$this->data['code'] = $this->request->post['code'];


		} elseif (isset($zone_info)) {


			$this->data['code'] = $zone_info['code'];


		} else {


			$this->data['code'] = '';


		}





		if (isset($this->request->post['country_id'])) {


			$this->data['country_id'] = $this->request->post['country_id'];


		} elseif (isset($zone_info)) {


			$this->data['country_id'] = $zone_info['country_id'];


		} else {


			$this->data['country_id'] = '';


		}


		


		$this->load->model('localisation/country');


		


		$this->data['countries'] = $this->model_localisation_country->getCountries();





		$this->template = 'localisation/zone_form.tpl';


		$this->children = array(


			'common/header',


			'common/footer'


		);


				


		$this->response->setOutput($this->render());


	}





	private function validateForm() {


		if (!$this->user->hasPermission('modify', 'localisation/zone')) {


			$this->error['warning'] = $this->language->get('error_permission');


		}





		if ((utf8_strlen($this->request->post['name']) < 3) || (utf8_strlen($this->request->post['name']) > 64)) {


			$this->error['name'] = $this->language->get('error_name');


		}





		if (!$this->error) {


			return true;


		} else {


			return false;


		}


	}





	private function validateDelete() {


		if (!$this->user->hasPermission('modify', 'localisation/zone')) {


			$this->error['warning'] = $this->language->get('error_permission');


		}


		


		$this->load->model('setting/store');


		$this->load->model('sale/customer');


		$this->load->model('sale/affiliate');


		$this->load->model('localisation/geo_zone');


		


		foreach ($this->request->post['selected'] as $zone_id) {


			if ($this->config->get('config_zone_id') == $zone_id) {


				$this->error['warning'] = $this->language->get('error_default');


			}


			


			$store_total = $this->model_setting_store->getTotalStoresByZoneId($zone_id);





			if ($store_total) {


				$this->error['warning'] = sprintf($this->language->get('error_store'), $store_total);


			}


		


			$address_total = $this->model_sale_customer->getTotalAddressesByZoneId($zone_id);





			if ($address_total) {


				$this->error['warning'] = sprintf($this->language->get('error_address'), $address_total);


			}





			$affiliate_total = $this->model_sale_affiliate->getTotalAffiliatesByZoneId($zone_id);





			if ($affiliate_total) {


				$this->error['warning'] = sprintf($this->language->get('error_affiliate'), $affiliate_total);


			}


					


			$zone_to_geo_zone_total = $this->model_localisation_geo_zone->getTotalZoneToGeoZoneByZoneId($zone_id);


		


			if ($zone_to_geo_zone_total) {


				$this->error['warning'] = sprintf($this->language->get('error_zone_to_geo_zone'), $zone_to_geo_zone_total);


			}


		}


		


		if (!$this->error) {


			return true;


		} else {


			return false;


		}


	}


}


?>