<?php


class ControllerReportSaleReturn extends Controller {


	public function index() {     


		$this->load->language('report/sale_return');





		$this->document->setTitle($this->language->get('heading_title'));


		


		if (isset($this->request->get['filter_date_start'])) {


			$filter_date_start = $this->request->get['filter_date_start'];


		} else {


			$filter_date_start = '';


		}





		if (isset($this->request->get['filter_date_end'])) {


			$filter_date_end = $this->request->get['filter_date_end'];


		} else {


			$filter_date_end = '';


		}


		


		if (isset($this->request->get['filter_group'])) {


			$filter_group = $this->request->get['filter_group'];


		} else {


			$filter_group = 'week';


		}


		


		if (isset($this->request->get['filter_return_status_id'])) {


			$filter_return_status_id = $this->request->get['filter_return_status_id'];


		} else {


			$filter_return_status_id = 0;


		}	


		


		if (isset($this->request->get['page'])) {


			$page = $this->request->get['page'];


		} else {


			$page = 1;


		}





		$url = '';


		


		if (isset($this->request->get['filter_date_start'])) {


			$url .= '&filter_date_start=' . $this->request->get['filter_date_start'];


		}


		


		if (isset($this->request->get['filter_date_end'])) {


			$url .= '&filter_date_end=' . $this->request->get['filter_date_end'];


		}


		


		if (isset($this->request->get['filter_group'])) {


			$url .= '&filter_group=' . $this->request->get['filter_group'];


		}		





		if (isset($this->request->get['filter_return_status_id'])) {


			$url .= '&filter_return_status_id=' . $this->request->get['filter_return_status_id'];


		}


				


		if (isset($this->request->get['page'])) {


			$url .= '&page=' . $this->request->get['page'];


		}


						


		$this->data['breadcrumbs'] = array();





   		$this->data['breadcrumbs'][] = array(


       		'text'      => $this->language->get('text_home'),


			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),


      		'separator' => false


   		);





   		$this->data['breadcrumbs'][] = array(


       		'text'      => $this->language->get('heading_title'),


			'href'      => $this->url->link('report/sale_return', 'token=' . $this->session->data['token'] . $url, 'SSL'),


      		'separator' => ' :: '


   		);		


		


		$this->load->model('report/return');


		


		$this->data['returns'] = array();


		


		$data = array(


			'filter_date_start'	      => $filter_date_start, 


			'filter_date_end'	      => $filter_date_end, 


			'filter_group'            => $filter_group,


			'filter_return_status_id' => $filter_return_status_id,


			'start'                   => ($page - 1) * $this->config->get('config_admin_limit'),


			'limit'                   => $this->config->get('config_admin_limit')


		);


		


		$return_total = $this->model_report_return->getTotalReturns($data);


		


		$results = $this->model_report_return->getReturns($data);


		


		foreach ($results as $result) {


			$this->data['returns'][] = array(


				'date_start' => date($this->language->get('date_format_short'), strtotime($result['date_start'])),


				'date_end'   => date($this->language->get('date_format_short'), strtotime($result['date_end'])),


				'returns'    => $result['returns'],


				'products'   => $result['products']


			);


		}


				 


 		$this->data['heading_title'] = $this->language->get('heading_title');


		 


		$this->data['text_no_results'] = $this->language->get('text_no_results');


		$this->data['text_all_status'] = $this->language->get('text_all_status');


		


		$this->data['column_date_start'] = $this->language->get('column_date_start');


		$this->data['column_date_end'] = $this->language->get('column_date_end');


    	$this->data['column_returns'] = $this->language->get('column_returns');


		$this->data['column_products'] = $this->language->get('column_products');


		$this->data['column_total'] = $this->language->get('column_total');


		


		$this->data['entry_date_start'] = $this->language->get('entry_date_start');


		$this->data['entry_date_end'] = $this->language->get('entry_date_end');


		$this->data['entry_group'] = $this->language->get('entry_group');	


		$this->data['entry_status'] = $this->language->get('entry_status');


				


		$this->data['button_filter'] = $this->language->get('button_filter');


		


		$this->data['token'] = $this->session->data['token'];


		


		$this->load->model('localisation/return_status');


		


		$this->data['return_statuses'] = $this->model_localisation_return_status->getReturnStatuses();





		$this->data['groups'] = array();





		$this->data['groups'][] = array(


			'text'  => $this->language->get('text_year'),


			'value' => 'year',


		);





		$this->data['groups'][] = array(


			'text'  => $this->language->get('text_month'),


			'value' => 'month',


		);





		$this->data['groups'][] = array(


			'text'  => $this->language->get('text_week'),


			'value' => 'week',


		);





		$this->data['groups'][] = array(


			'text'  => $this->language->get('text_day'),


			'value' => 'day',


		);





		$url = '';


						


		if (isset($this->request->get['filter_date_start'])) {


			$url .= '&filter_date_start=' . $this->request->get['filter_date_start'];


		}


		


		if (isset($this->request->get['filter_date_end'])) {


			$url .= '&filter_date_end=' . $this->request->get['filter_date_end'];


		}


		


		if (isset($this->request->get['filter_group'])) {


			$url .= '&filter_group=' . $this->request->get['filter_group'];


		}		





		if (isset($this->request->get['filter_return_status_id'])) {


			$url .= '&filter_return_status_id=' . $this->request->get['filter_return_status_id'];


		}


				


		$pagination = new Pagination();


		$pagination->total = $return_total;


		$pagination->page = $page;


		$pagination->limit = $this->config->get('config_admin_limit');


		$pagination->text = $this->language->get('text_pagination');


		$pagination->url = $this->url->link('report/sale_return', 'token=' . $this->session->data['token'] . $url . '&page={page}', 'SSL');


			


		$this->data['pagination'] = $pagination->render();


		


		$this->data['filter_date_start'] = $filter_date_start;


		$this->data['filter_date_end'] = $filter_date_end;		


		$this->data['filter_group'] = $filter_group;


		$this->data['filter_return_status_id'] = $filter_return_status_id;


				 


		$this->template = 'report/sale_return.tpl';


		$this->children = array(


			'common/header',


			'common/footer'


		);


				


		$this->response->setOutput($this->render());


	}


}


?>