<?php


class ControllerUserUserPermission extends Controller {


	private $error = array();


 


	public function index() {


		$this->load->language('user/user_group');


 


		$this->document->setTitle($this->language->get('heading_title'));


 		


		$this->load->model('user/user_group');


		


		$this->getList();


	}





	public function insert() {


		$this->load->language('user/user_group');





		$this->document->setTitle($this->language->get('heading_title'));


		


		$this->load->model('user/user_group');


		


		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {


			$this->model_user_user_group->addUserGroup($this->request->post);


			


			$this->session->data['success'] = $this->language->get('text_success');





			$url = '';





			if (isset($this->request->get['sort'])) {


				$url .= '&sort=' . $this->request->get['sort'];


			}





			if (isset($this->request->get['order'])) {


				$url .= '&order=' . $this->request->get['order'];


			}


			


			if (isset($this->request->get['page'])) {


				$url .= '&page=' . $this->request->get['page'];


			}


						


			$this->redirect($this->url->link('user/user_permission', 'token=' . $this->session->data['token'] . $url, 'SSL'));


		}





		$this->getForm();


	}





	public function update() {


		$this->load->language('user/user_group');





		$this->document->setTitle($this->language->get('heading_title'));


		


		$this->load->model('user/user_group');


		


		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validateForm()) {


			$this->model_user_user_group->editUserGroup($this->request->get['user_group_id'], $this->request->post);


			


			$this->session->data['success'] = $this->language->get('text_success');


			


			$url = '';





			if (isset($this->request->get['sort'])) {


				$url .= '&sort=' . $this->request->get['sort'];


			}





			if (isset($this->request->get['order'])) {


				$url .= '&order=' . $this->request->get['order'];


			}





			if (isset($this->request->get['page'])) {


				$url .= '&page=' . $this->request->get['page'];


			}


						


			$this->redirect($this->url->link('user/user_permission', 'token=' . $this->session->data['token'] . $url, 'SSL'));


		}





		$this->getForm();


	}





	public function delete() { 


		$this->load->language('user/user_group');





		$this->document->setTitle($this->language->get('heading_title'));


		


		$this->load->model('user/user_group');


		


		if (isset($this->request->post['selected']) && $this->validateDelete()) {


      		foreach ($this->request->post['selected'] as $user_group_id) {


				$this->model_user_user_group->deleteUserGroup($user_group_id);	


			}


						


			$this->session->data['success'] = $this->language->get('text_success');


			


			$url = '';





			if (isset($this->request->get['sort'])) {


				$url .= '&sort=' . $this->request->get['sort'];


			}





			if (isset($this->request->get['order'])) {


				$url .= '&order=' . $this->request->get['order'];


			}





			if (isset($this->request->get['page'])) {


				$url .= '&page=' . $this->request->get['page'];


			}


						


			$this->redirect($this->url->link('user/user_permission', 'token=' . $this->session->data['token'] . $url, 'SSL'));


		}





		$this->getList();


	}





	private function getList() {


		if (isset($this->request->get['sort'])) {


			$sort = $this->request->get['sort'];


		} else {


			$sort = 'name';


		}


		 


		if (isset($this->request->get['order'])) {


			$order = $this->request->get['order'];


		} else {


			$order = 'ASC';


		}


		


		if (isset($this->request->get['page'])) {


			$page = $this->request->get['page'];


		} else {


			$page = 1;


		}


		


		$url = '';


		


		if (isset($this->request->get['sort'])) {


			$url .= '&sort=' . $this->request->get['sort'];


		}





		if (isset($this->request->get['order'])) {


			$url .= '&order=' . $this->request->get['order'];


		}	


	


		if (isset($this->request->get['page'])) {


			$url .= '&page=' . $this->request->get['page'];


		}


			


  		$this->data['breadcrumbs'] = array();





   		$this->data['breadcrumbs'][] = array(


       		'text'      => $this->language->get('text_home'),


			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),


      		'separator' => false


   		);





   		$this->data['breadcrumbs'][] = array(


       		'text'      => $this->language->get('heading_title'),


			'href'      => $this->url->link('user/user_permission', 'token=' . $this->session->data['token'] . $url, 'SSL'),


      		'separator' => ' :: '


   		);


							


		$this->data['insert'] = $this->url->link('user/user_permission/insert', 'token=' . $this->session->data['token'] . $url, 'SSL');


		$this->data['delete'] = $this->url->link('user/user_permission/delete', 'token=' . $this->session->data['token'] . $url, 'SSL');	


	


		$this->data['user_groups'] = array();





		$data = array(


			'sort'  => $sort,


			'order' => $order,


			'start' => ($page - 1) * $this->config->get('config_admin_limit'),


			'limit' => $this->config->get('config_admin_limit')


		);


		


		$user_group_total = $this->model_user_user_group->getTotalUserGroups();


		


		$results = $this->model_user_user_group->getUserGroups($data);





		foreach ($results as $result) {


			$action = array();


			


			$action[] = array(


				'text' => $this->language->get('text_edit'),


				'href' => $this->url->link('user/user_permission/update', 'token=' . $this->session->data['token'] . '&user_group_id=' . $result['user_group_id'] . $url, 'SSL')


			);		


		


			$this->data['user_groups'][] = array(


				'user_group_id' => $result['user_group_id'],


				'name'          => $result['name'],


				'selected'      => isset($this->request->post['selected']) && in_array($result['user_group_id'], $this->request->post['selected']),


				'action'        => $action


			);


		}	


	


		$this->data['heading_title'] = $this->language->get('heading_title');


		


		$this->data['text_no_results'] = $this->language->get('text_no_results');





		$this->data['column_name'] = $this->language->get('column_name');


		$this->data['column_action'] = $this->language->get('column_action');





		$this->data['button_insert'] = $this->language->get('button_insert');


		$this->data['button_delete'] = $this->language->get('button_delete');


 


 		if (isset($this->error['warning'])) {


			$this->data['error_warning'] = $this->error['warning'];


		} else {


			$this->data['error_warning'] = '';


		}


		


		if (isset($this->session->data['success'])) {


			$this->data['success'] = $this->session->data['success'];


		


			unset($this->session->data['success']);


		} else {


			$this->data['success'] = '';


		}


		


		$url = '';





		if ($order == 'ASC') {


			$url .= '&order=DESC';


		} else {


			$url .= '&order=ASC';


		}





		if (isset($this->request->get['page'])) {


			$url .= '&page=' . $this->request->get['page'];


		}





		$this->data['sort_name'] = $this->url->link('user/user_permission', 'token=' . $this->session->data['token'] . '&sort=name' . $url, 'SSL');


		


		$url = '';





		if (isset($this->request->get['sort'])) {


			$url .= '&sort=' . $this->request->get['sort'];


		}


												


		if (isset($this->request->get['order'])) {


			$url .= '&order=' . $this->request->get['order'];


		}


				


		$pagination = new Pagination();


		$pagination->total = $user_group_total;


		$pagination->page = $page;


		$pagination->limit = $this->config->get('config_admin_limit');


		$pagination->text = $this->language->get('text_pagination');


		$pagination->url = $this->url->link('user/user_permission', 'token=' . $this->session->data['token'] . $url . '&page={page}', 'SSL');


		


		$this->data['pagination'] = $pagination->render();				





		$this->data['sort'] = $sort; 


		$this->data['order'] = $order;





		$this->template = 'user/user_group_list.tpl';


		$this->children = array(


			'common/header',


			'common/footer'


		);


				


		$this->response->setOutput($this->render());


 	}





	private function getForm() {


		$this->data['heading_title'] = $this->language->get('heading_title');


		


		$this->data['text_select_all'] = $this->language->get('text_select_all');


		$this->data['text_unselect_all'] = $this->language->get('text_unselect_all');


				


		$this->data['entry_name'] = $this->language->get('entry_name');


		$this->data['entry_access'] = $this->language->get('entry_access');


		$this->data['entry_modify'] = $this->language->get('entry_modify');


		


		$this->data['button_save'] = $this->language->get('button_save');


		$this->data['button_cancel'] = $this->language->get('button_cancel');





		$this->data['tab_general'] = $this->language->get('tab_general');





 		if (isset($this->error['warning'])) {


			$this->data['error_warning'] = $this->error['warning'];


		} else {


			$this->data['error_warning'] = '';


		}


		


 		if (isset($this->error['name'])) {


			$this->data['error_name'] = $this->error['name'];


		} else {


			$this->data['error_name'] = '';


		}





		$url = '';





		if (isset($this->request->get['sort'])) {


			$url .= '&sort=' . $this->request->get['sort'];


		}





		if (isset($this->request->get['order'])) {


			$url .= '&order=' . $this->request->get['order'];


		}


			


		if (isset($this->request->get['page'])) {


			$url .= '&page=' . $this->request->get['page'];


		}


		


  		$this->data['breadcrumbs'] = array();





   		$this->data['breadcrumbs'][] = array(


       		'text'      => $this->language->get('text_home'),


			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),


      		'separator' => false


   		);





   		$this->data['breadcrumbs'][] = array(


       		'text'      => $this->language->get('heading_title'),


			'href'      => $this->url->link('user/user_permission', 'token=' . $this->session->data['token'] . $url, 'SSL'),


      		'separator' => ' :: '


   		);


			


		if (!isset($this->request->get['user_group_id'])) {


			$this->data['action'] = $this->url->link('user/user_permission/insert', 'token=' . $this->session->data['token'] . $url, 'SSL');


		} else {


			$this->data['action'] = $this->url->link('user/user_permission/update', 'token=' . $this->session->data['token'] . '&user_group_id=' . $this->request->get['user_group_id'] . $url, 'SSL');


		}


		  


    	$this->data['cancel'] = $this->url->link('user/user_permission', 'token=' . $this->session->data['token'] . $url, 'SSL');





		if (isset($this->request->get['user_group_id']) && $this->request->server['REQUEST_METHOD'] != 'POST') {


			$user_group_info = $this->model_user_user_group->getUserGroup($this->request->get['user_group_id']);


		}





		if (isset($this->request->post['name'])) {


			$this->data['name'] = $this->request->post['name'];


		} elseif (!empty($user_group_info)) {


			$this->data['name'] = $user_group_info['name'];


		} else {


			$this->data['name'] = '';


		}


		


		$ignore = array(


			'common/home',


			'common/startup',


			'common/login',


			'common/logout',


			'common/forgotten',


			'common/reset',			


			'error/not_found',


			'error/permission',


			'common/footer',


			'common/header'


		);


				


		$this->data['permissions'] = array();


		


		$files = glob(DIR_APPLICATION . 'controller/*/*.php');


		


		foreach ($files as $file) {


			$data = explode('/', dirname($file));


			


			$permission = end($data) . '/' . basename($file, '.php');


			


			if (!in_array($permission, $ignore)) {


				$this->data['permissions'][] = $permission;


			}


		}


		


		if (isset($this->request->post['permission'])) {


			$this->data['access'] = $this->request->post['permission']['access'];


		} elseif (isset($user_group_info['permission']['access'])) {


			$this->data['access'] = $user_group_info['permission']['access'];


		} else { 


			$this->data['access'] = array();


		}





		if (isset($this->request->post['permission'])) {


			$this->data['modify'] = $this->request->post['permission']['modify'];


		} elseif (isset($user_group_info['permission']['modify'])) {


			$this->data['modify'] = $user_group_info['permission']['modify'];


		} else { 


			$this->data['modify'] = array();


		}


	


		$this->template = 'user/user_group_form.tpl';


		$this->children = array(


			'common/header',


			'common/footer'


		);


				


		$this->response->setOutput($this->render());


	}





	private function validateForm() {


		if (!$this->user->hasPermission('modify', 'user/user_permission')) {


			$this->error['warning'] = $this->language->get('error_permission');


		}





		if ((utf8_strlen($this->request->post['name']) < 3) || (utf8_strlen($this->request->post['name']) > 64)) {


			$this->error['name'] = $this->language->get('error_name');


		}





		if (!$this->error) {


			return true;


		} else {


			return false;


		}


	}





	private function validateDelete() {


		if (!$this->user->hasPermission('modify', 'user/user_permission')) {


			$this->error['warning'] = $this->language->get('error_permission');


		}


		


		$this->load->model('user/user');


      	


		foreach ($this->request->post['selected'] as $user_group_id) {


			$user_total = $this->model_user_user->getTotalUsersByGroupId($user_group_id);





			if ($user_total) {


				$this->error['warning'] = sprintf($this->language->get('error_user'), $user_total);


			}


		}


		


		if (!$this->error) {


			return true;


		} else {


			return false;


		}


	}


}


?>