<?php

class ModelCatalogManufacturer extends Model {

	public function addManufacturer($data) {

      	$this->db->query("INSERT INTO " . DB_PREFIX . "manufacturer SET name = '" . $this->db->escape($data['name']) . "', sort_order = '" . (int)$data['sort_order'] . "'");

		

		$manufacturer_id = $this->db->getLastId();



		if (isset($data['image'])) {

			$this->db->query("UPDATE " . DB_PREFIX . "manufacturer SET image = '" . $this->db->escape($data['image']) . "' WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");

		}

		

		if (isset($data['manufacturer_store'])) {

			foreach ($data['manufacturer_store'] as $store_id) {

				$this->db->query("INSERT INTO " . DB_PREFIX . "manufacturer_to_store SET manufacturer_id = '" . (int)$manufacturer_id . "', store_id = '" . (int)$store_id . "'");

			}

		}

				

		if ($data['keyword']) {

			$this->db->query("INSERT INTO " . DB_PREFIX . "url_alias SET query = 'manufacturer_id=" . (int)$manufacturer_id . "', keyword = '" . $this->db->escape($data['keyword']) . "'");

		}

		

		$this->cache->delete('manufacturer');

	}

	

	public function editManufacturer($manufacturer_id, $data) {

      	$this->db->query("UPDATE " . DB_PREFIX . "manufacturer SET name = '" . $this->db->escape($data['name']) . "', sort_order = '" . (int)$data['sort_order'] . "' WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");



		if (isset($data['image'])) {

			$this->db->query("UPDATE " . DB_PREFIX . "manufacturer SET image = '" . $this->db->escape($data['image']) . "' WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");

		}

		

		$this->db->query("DELETE FROM " . DB_PREFIX . "manufacturer_to_store WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");



		if (isset($data['manufacturer_store'])) {

			foreach ($data['manufacturer_store'] as $store_id) {

				$this->db->query("INSERT INTO " . DB_PREFIX . "manufacturer_to_store SET manufacturer_id = '" . (int)$manufacturer_id . "', store_id = '" . (int)$store_id . "'");

			}

		}

			

		$this->db->query("DELETE FROM " . DB_PREFIX . "url_alias WHERE query = 'manufacturer_id=" . (int)$manufacturer_id. "'");

		

		if ($data['keyword']) {

			$this->db->query("INSERT INTO " . DB_PREFIX . "url_alias SET query = 'manufacturer_id=" . (int)$manufacturer_id . "', keyword = '" . $this->db->escape($data['keyword']) . "'");

		}

		

		$this->cache->delete('manufacturer');

	}

	

	public function deleteManufacturer($manufacturer_id) {

		$this->db->query("DELETE FROM " . DB_PREFIX . "manufacturer WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");

		$this->db->query("DELETE FROM " . DB_PREFIX . "manufacturer_to_store WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");

		$this->db->query("DELETE FROM " . DB_PREFIX . "url_alias WHERE query = 'manufacturer_id=" . (int)$manufacturer_id . "'");

			

		$this->cache->delete('manufacturer');

	}	

	

	public function getManufacturer($manufacturer_id) {

		$query = $this->db->query("SELECT DISTINCT *, (SELECT keyword FROM " . DB_PREFIX . "url_alias WHERE query = 'manufacturer_id=" . (int)$manufacturer_id . "') AS keyword FROM " . DB_PREFIX . "manufacturer WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");

		

		return $query->row;

	}

	

	public function getManufacturers($data = array()) {

		if ($data) {

			$sql = "SELECT * FROM " . DB_PREFIX . "manufacturer";

			

			$sort_data = array(

				'name',

				'sort_order'

			);	

			

			if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {

				$sql .= " ORDER BY " . $data['sort'];	

			} else {

				$sql .= " ORDER BY name";	

			}

			

			if (isset($data['order']) && ($data['order'] == 'DESC')) {

				$sql .= " DESC";

			} else {

				$sql .= " ASC";

			}

			

			if (isset($data['start']) || isset($data['limit'])) {

				if ($data['start'] < 0) {

					$data['start'] = 0;

				}					



				if ($data['limit'] < 1) {

					$data['limit'] = 20;

				}	

			

				$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];

			}				

			

			$query = $this->db->query($sql);

		

			return $query->rows;

		} else {

			$manufacturer_data = $this->cache->get('manufacturer');

		

			if (!$manufacturer_data) {

				$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "manufacturer ORDER BY name");

	

				$manufacturer_data = $query->rows;

			

				$this->cache->set('manufacturer', $manufacturer_data);

			}

		 

			return $manufacturer_data;

		}

	}

	

	public function getManufacturerStores($manufacturer_id) {

		$manufacturer_store_data = array();

		

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "manufacturer_to_store WHERE manufacturer_id = '" . (int)$manufacturer_id . "'");



		foreach ($query->rows as $result) {

			$manufacturer_store_data[] = $result['store_id'];

		}

		

		return $manufacturer_store_data;

	}

	

	public function getTotalManufacturersByImageId($image_id) {

      	$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "manufacturer WHERE image_id = '" . (int)$image_id . "'");



		return $query->row['total'];

	}



	public function getTotalManufacturers() {

      	$query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "manufacturer");

		

		return $query->row['total'];

	}	

}

?>