<?php 

class ControllerAffiliateLogin extends Controller {

	private $error = array();

	

	public function index() {

		if ($this->affiliate->isLogged()) {  

      		$this->redirect($this->url->link('affiliate/account', '', 'SSL'));

    	}

	

    	$this->language->load('affiliate/login');



    	$this->document->setTitle($this->language->get('heading_title')); 

						

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && isset($this->request->post['email']) && isset($this->request->post['password']) && $this->validate()) {

			if (isset($this->request->post['redirect'])) {

				$this->redirect(str_replace('&amp;', '&', $this->request->post['redirect']));

			} else {

				$this->redirect($this->url->link('affiliate/account', '', 'SSL'));

			} 

		}

		

      	$this->data['breadcrumbs'] = array();



      	$this->data['breadcrumbs'][] = array(

        	'text'      => $this->language->get('text_home'),

			'href'      => $this->url->link('common/home'),       	

        	'separator' => false

      	);

 

      	$this->data['breadcrumbs'][] = array(

        	'text'      => $this->language->get('text_account'),

			'href'      => $this->url->link('affiliate/account', '', 'SSL'),

        	'separator' => $this->language->get('text_separator')

      	);

		

      	$this->data['breadcrumbs'][] = array(

        	'text'      => $this->language->get('text_login'),

			'href'      => $this->url->link('affiliate/login', '', 'SSL'),      	

        	'separator' => $this->language->get('text_separator')

      	);

				

    	$this->data['heading_title'] = $this->language->get('heading_title');

		

		$this->data['text_description'] = sprintf($this->language->get('text_description'), $this->config->get('config_name'), $this->config->get('config_name'), $this->config->get('config_commission') . '%');

		$this->data['text_new_affiliate'] = $this->language->get('text_new_affiliate');

    	$this->data['text_register_account'] = $this->language->get('text_register_account'); 	

		$this->data['text_returning_affiliate'] = $this->language->get('text_returning_affiliate');

		$this->data['text_i_am_returning_affiliate'] = $this->language->get('text_i_am_returning_affiliate');

    	$this->data['text_forgotten'] = $this->language->get('text_forgotten');



    	$this->data['entry_email'] = $this->language->get('entry_email');

    	$this->data['entry_password'] = $this->language->get('entry_password');



    	$this->data['button_continue'] = $this->language->get('button_continue');

		$this->data['button_login'] = $this->language->get('button_login');



		if (isset($this->error['warning'])) {

			$this->data['error_warning'] = $this->error['warning'];

		} else {

			$this->data['error_warning'] = '';

		}

		

		$this->data['action'] = $this->url->link('affiliate/login', '', 'SSL');

		$this->data['register'] = $this->url->link('affiliate/register', '', 'SSL');

		$this->data['forgotten'] = $this->url->link('affiliate/forgotten', '', 'SSL');

    	

		if (isset($this->request->post['redirect'])) {

			$this->data['redirect'] = $this->request->post['redirect'];

		} elseif (isset($this->session->data['redirect'])) {

      		$this->data['redirect'] = $this->session->data['redirect'];

	  		

			unset($this->session->data['redirect']);		  	

    	} else {

			$this->data['redirect'] = '';

		}



		if (isset($this->session->data['success'])) {

    		$this->data['success'] = $this->session->data['success'];

    

			unset($this->session->data['success']);

		} else {

			$this->data['success'] = '';

		}

		

		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/affiliate/login.tpl')) {

			$this->template = $this->config->get('config_template') . '/template/affiliate/login.tpl';

		} else {

			$this->template = 'default/template/affiliate/login.tpl';

		}

		

		$this->children = array(

			'common/column_left',

			'common/column_right',

			'common/content_top',

			'common/content_bottom',

			'common/footer',

			'common/header'	

		);

						

		$this->response->setOutput($this->render());

  	}

  

  	private function validate() {

    	if (!$this->affiliate->login($this->request->post['email'], $this->request->post['password'])) {

      		$this->error['warning'] = $this->language->get('error_login');

    	}

	

    	if (!$this->error) {

      		return true;

    	} else {

      		return false;

    	}  	

  	}

}

?>