<?php


class ControllerPaymentPPPro extends Controller {


	protected function index() {


    	$this->language->load('payment/pp_pro');


		


		$this->data['text_credit_card'] = $this->language->get('text_credit_card');


		$this->data['text_start_date'] = $this->language->get('text_start_date');


		$this->data['text_issue'] = $this->language->get('text_issue');


		$this->data['text_wait'] = $this->language->get('text_wait');


		


		$this->data['entry_cc_type'] = $this->language->get('entry_cc_type');


		$this->data['entry_cc_number'] = $this->language->get('entry_cc_number');


		$this->data['entry_cc_start_date'] = $this->language->get('entry_cc_start_date');


		$this->data['entry_cc_expire_date'] = $this->language->get('entry_cc_expire_date');


		$this->data['entry_cc_cvv2'] = $this->language->get('entry_cc_cvv2');


		$this->data['entry_cc_issue'] = $this->language->get('entry_cc_issue');


		


		$this->data['button_confirm'] = $this->language->get('button_confirm');


		


		$this->data['cards'] = array();





		$this->data['cards'][] = array(


			'text'  => 'Visa', 


			'value' => 'VISA'


		);





		$this->data['cards'][] = array(


			'text'  => 'MasterCard', 


			'value' => 'MASTERCARD'


		);





		$this->data['cards'][] = array(


			'text'  => 'Discover Card', 


			'value' => 'DISCOVER'


		);


		


		$this->data['cards'][] = array(


			'text'  => 'American Express', 


			'value' => 'AMEX'


		);





		$this->data['cards'][] = array(


			'text'  => 'Maestro', 


			'value' => 'SWITCH'


		);


		


		$this->data['cards'][] = array(


			'text'  => 'Solo', 


			'value' => 'SOLO'


		);		


	


		$this->data['months'] = array();


		


		for ($i = 1; $i <= 12; $i++) {


			$this->data['months'][] = array(


				'text'  => strftime('%B', mktime(0, 0, 0, $i, 1, 2000)), 


				'value' => sprintf('%02d', $i)


			);


		}


		


		$today = getdate();


		


		$this->data['year_valid'] = array();


		


		for ($i = $today['year'] - 10; $i < $today['year'] + 1; $i++) {	


			$this->data['year_valid'][] = array(


				'text'  => strftime('%Y', mktime(0, 0, 0, 1, 1, $i)), 


				'value' => strftime('%Y', mktime(0, 0, 0, 1, 1, $i))


			);


		}





		$this->data['year_expire'] = array();





		for ($i = $today['year']; $i < $today['year'] + 11; $i++) {


			$this->data['year_expire'][] = array(


				'text'  => strftime('%Y', mktime(0, 0, 0, 1, 1, $i)),


				'value' => strftime('%Y', mktime(0, 0, 0, 1, 1, $i)) 


			);


		}


		


		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/pp_pro.tpl')) {


			$this->template = $this->config->get('config_template') . '/template/payment/pp_pro.tpl';


		} else {


			$this->template = 'default/template/payment/pp_pro.tpl';


		}	


		


		$this->render();		


	}





	public function send() {


		if (!$this->config->get('pp_pro_transaction')) {


			$payment_type = 'Authorization';	


		} else {


			$payment_type = 'Sale';


		}


		


		$this->load->model('checkout/order');


		


		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);


		


		$request  = 'METHOD=DoDirectPayment';


		$request .= '&VERSION=51.0';


		$request .= '&USER=' . urlencode($this->config->get('pp_pro_username'));


		$request .= '&PWD=' . urlencode($this->config->get('pp_pro_password'));


		$request .= '&SIGNATURE=' . urlencode($this->config->get('pp_pro_signature'));


		$request .= '&CUSTREF=' . (int)$order_info['order_id'];


		$request .= '&PAYMENTACTION=' . $payment_type;


		$request .= '&AMT=' . $this->currency->format($order_info['total'], $order_info['currency_code'], false, false);


		$request .= '&CREDITCARDTYPE=' . $this->request->post['cc_type'];


		$request .= '&ACCT=' . urlencode(str_replace(' ', '', $this->request->post['cc_number']));


		$request .= '&CARDSTART=' . urlencode($this->request->post['cc_start_date_month'] . $this->request->post['cc_start_date_year']);


		$request .= '&EXPDATE=' . urlencode($this->request->post['cc_expire_date_month'] . $this->request->post['cc_expire_date_year']);


		$request .= '&CVV2=' . urlencode($this->request->post['cc_cvv2']);


		$request .= '&CARDISSUE=' . urlencode($this->request->post['cc_issue']);


		$request .= '&FIRSTNAME=' . urlencode($order_info['payment_firstname']);


		$request .= '&LASTNAME=' . urlencode($order_info['payment_lastname']);


		$request .= '&EMAIL=' . urlencode($order_info['email']);


		$request .= '&PHONENUM=' . urlencode($order_info['telephone']);


		$request .= '&IPADDRESS=' . urlencode($this->request->server['REMOTE_ADDR']);


		$request .= '&STREET=' . urlencode($order_info['payment_address_1']);


		$request .= '&CITY=' . urlencode($order_info['payment_city']);


		$request .= '&STATE=' . urlencode(($order_info['payment_iso_code_2'] != 'US') ? $order_info['payment_zone'] : $order_info['payment_zone_code']);


		$request .= '&ZIP=' . urlencode($order_info['payment_postcode']);


		$request .= '&COUNTRYCODE=' . urlencode($order_info['payment_iso_code_2']);


		$request .= '&CURRENCYCODE=' . urlencode($order_info['currency_code']);


		


		if (!$this->config->get('pp_pro_test')) {


			$curl = curl_init('https://api-3t.paypal.com/nvp');


		} else {


			$curl = curl_init('https://api-3t.sandbox.paypal.com/nvp');


		}


		


		curl_setopt($curl, CURLOPT_PORT, 443);


		curl_setopt($curl, CURLOPT_HEADER, 0);


		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);


		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);


        curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);


        curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);


        curl_setopt($curl, CURLOPT_POST, 1);


        curl_setopt($curl, CURLOPT_POSTFIELDS, $request);





		$response = curl_exec($curl);


 		


		curl_close($curl);


 


		if (!$response) {


			$this->log->write('DoDirectPayment failed: ' . curl_error($curl) . '(' . curl_errno($curl) . ')');


		}


 


 		$response_data = array();


 


		parse_str($response, $response_data);





		$json = array();


		


		if (($response_data['ACK'] == 'Success') || ($response_data['ACK'] == 'SuccessWithWarning')) {


			$this->model_checkout_order->confirm($this->session->data['order_id'], $this->config->get('config_order_status_id'));


			


			$message = '';


			


			if (isset($response_data['AVSCODE'])) {


				$message .= 'AVSCODE: ' . $response_data['AVSCODE'] . "\n";


			}





			if (isset($response_data['CVV2MATCH'])) {


				$message .= 'CVV2MATCH: ' . $response_data['CVV2MATCH'] . "\n";


			}





			if (isset($response_data['TRANSACTIONID'])) {


				$message .= 'TRANSACTIONID: ' . $response_data['TRANSACTIONID'] . "\n";


			}


			


			$this->model_checkout_order->update($this->session->data['order_id'], $this->config->get('pp_pro_order_status_id'), $message, false);


		


			$json['success'] = $this->url->link('checkout/success');


		} else {


        	$json['error'] = $response_data['L_LONGMESSAGE0'];


        }


		


		$this->response->setOutput(json_encode($json));


	}


}


?>