<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/1999/REC-html401-19991224/strict.dtd">


<html>


<head>


<meta http-equiv="Content-Type" content="text/html; charset=utf-8">


<title><?php echo $title; ?></title>


<style type="text/css">


body {


	color: #000000;


	font-family: Arial, Helvetica, sans-serif;


}


body, td, th, input, textarea, select, a {


	font-size: 12px;


}


p {


	margin-top: 0px;


	margin-bottom: 20px;


}


a, a:visited, a b {


	color: #378DC1;


	text-decoration: underline;


	cursor: pointer;


}


a:hover {


	text-decoration: none;


}


a img {


	border: none;


}


#container {


	width: 680px;


}


#logo {


	margin-bottom: 20px;


}


table.list {


	border-collapse: collapse;


	width: 100%;


	border-top: 1px solid #DDDDDD;


	border-left: 1px solid #DDDDDD;


	margin-bottom: 20px;


}


table.list td {


	border-right: 1px solid #DDDDDD;


	border-bottom: 1px solid #DDDDDD;


}


table.list thead td {


	background-color: #EFEFEF;


	padding: 0px 5px;


}


table.list thead td a, .list thead td {


	text-decoration: none;


	color: #222222;


	font-weight: bold;


}


table.list tbody td a {


	text-decoration: underline;


}


table.list tbody td {


	vertical-align: top;


	padding: 0px 5px;


}


table.list .left {


	text-align: left;


	padding: 7px;


}


table.list .right {


	text-align: right;


	padding: 7px;


}


table.list .center {


	text-align: center;


	padding: 7px;


}


</style>


</head>


<body>


<div id="container"><a href="<?php echo $store_url; ?>" title="<?php echo $store_name; ?>"><img src="<?php echo $logo; ?>" alt="<?php echo $store_name; ?>" id="logo" /></a>


  <p><?php echo $text_greeting; ?></p>


  <?php if ($customer_id) { ?>


  <p><?php echo $text_link; ?></p>


  <p><a href="<?php echo $link; ?>"><?php echo $link; ?></a></p>


  <?php } ?>


  <?php if ($download) { ?>


  <p><?php echo $text_download; ?></p>


  <p><a href="<?php echo $download; ?>"><?php echo $download; ?></a></p>


  <?php } ?>


  <table class="list">


    <thead>


      <tr>


        <td class="left" colspan="2"><?php echo $text_order_detail; ?></td>


      </tr>


    </thead>


    <tbody>


      <tr>


        <td class="left"><b><?php echo $text_order_id; ?></b> <?php echo $order_id; ?><br />


          <b><?php echo $text_date_added; ?></b> <?php echo $date_added; ?><br />


          <b><?php echo $text_payment_method; ?></b> <?php echo $payment_method; ?><br />


          <?php if ($shipping_method) { ?>


          <b><?php echo $text_shipping_method; ?></b> <?php echo $shipping_method; ?>


          <?php } ?></td>


        <td class="left"><b><?php echo $text_email; ?></b> <?php echo $email; ?><br />


          <b><?php echo $text_telephone; ?></b> <?php echo $telephone; ?><br />


          <b><?php echo $text_ip; ?></b> <?php echo $ip; ?><br /></td>


      </tr>


    </tbody>


  </table>


  <?php if ($comment) { ?>


    <table class="list">


    <thead>


      <tr>


        <td class="left"><?php echo $text_instruction; ?></td>


      </tr>


    </thead>


    <tbody>


      <tr>


        <td class="left"><?php echo $comment; ?></td>


      </tr>


    </tbody>


  </table>


  <?php } ?>


  <table class="list">


    <thead>


      <tr>


        <td class="left"><?php echo $text_payment_address; ?></td>


        <?php if ($shipping_address) { ?>


        <td class="left"><?php echo $text_shipping_address; ?></td>


        <?php } ?>


      </tr>


    </thead>


    <tbody>


      <tr>


        <td class="left"><?php echo $payment_address; ?></td>


        <?php if ($shipping_address) { ?>


        <td class="left"><?php echo $shipping_address; ?></td>


        <?php } ?>


      </tr>


    </tbody>


  </table>


  <table class="list">


    <thead>


      <tr>


        <td class="left"><?php echo $text_product; ?></td>


        <td class="left"><?php echo $text_model; ?></td>


        <td class="right"><?php echo $text_quantity; ?></td>


        <td class="right"><?php echo $text_price; ?></td>


        <td class="right"><?php echo $text_total; ?></td>


      </tr>


    </thead>


    <tbody>


      <?php foreach ($products as $product) { ?>


      <tr>


        <td class="left"><?php echo $product['name']; ?>


          <?php foreach ($product['option'] as $option) { ?>


          <br />


          &nbsp;<small> - <?php echo $option['name']; ?>: <?php echo $option['value']; ?></small>


          <?php } ?></td>


        <td class="left"><?php echo $product['model']; ?></td>


        <td class="right"><?php echo $product['quantity']; ?></td>


        <td class="right"><?php echo $product['price']; ?></td>


        <td class="right"><?php echo $product['total']; ?></td>


      </tr>


      <?php } ?>


    </tbody>


    <tfoot>


      <?php foreach ($totals as $total) { ?>


      <tr>


        <td colspan="4" class="right"><b><?php echo $total['title']; ?>:</b></td>


        <td class="right"><?php echo $total['text']; ?></td>


      </tr>


      <?php } ?>


    </tfoot>


  </table>


  <p><?php echo $text_footer; ?></p>


  <p><?php echo $text_powered; ?></p>


</div>


</body>


</html>


